#include "GetObjects.js"

/*
Pauls's variantion of nudge script
it moves an objects according to "view (cplane) coordinates
and not world coordinates
*/


function DoNudge()
{
	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.allowEditPoints();
	if ( !GetObjects( objectpicker, true ) )
		return;
		
	var objects = objectpicker.objects;
	if ( objects.length == 0 )
		return;
		
	var factory = moi.command.createFactory( 'move' );
	factory.setInput( 0, objects );
	
	var axis = 'x';

	var dist = 1.0;   	// nudge distance desired.
	//var dist = 0.0625;   	//  1/16"

	// Get the parameters that were included when this command was executed.
	var params = moi.command.getCommandLineParams();

	// Test for which viewport the mouse is in
	var view_name = moi.ui.getActiveViewport().Name;

	if ( params.search( /right/i ) != -1 )  // The parameters contain the word "right" in it.
	{
		switch ( view_name )
		//  and adjust the axis accordingly.
		{
			case  'Right' : axis = 'y'; break;
			case  '3D'    : axis = 'x'; break;
		}
	}
	else if ( params.search( /left/i ) != -1 )    // The parameters contain the word "left" in it.
	{
		switch ( view_name )
		{
			case  'Right' : axis = 'y'; break;
			case  '3D'    : axis = 'x'; break;
		}
		dist = -dist;
	}
	else if ( params.search( /up/i ) != -1 )  	// The parameters contain the word "up" in it.
	{
		switch ( view_name )
		{
			case  'Top'   : axis = 'y'; break;
			case  'Front' : axis = 'z'; break;
			case  'Right' : axis = 'z'; break;
			case  '3D'    : axis = 'y'; break;
		}
	}
	else if ( params.search( /down/i ) != -1 )
	{
		var view_name = moi.ui.getActiveViewport().Name;
		switch (view_name)
		{
			case  'Top'   : axis = 'y'; break;
			case  'Front' : axis = 'z'; break;
			case  'Right' : axis = 'z'; break;
			case  '3D'    : axis = 'y'; break;
		}
		dist = -dist;
	}
	
	// We've got the direction set, now see if there were any parameters to modify the step size.
	
	if ( params.search( /large/i ) != -1 )
	{
		// The parameters contained the word "large" in it.
		dist *= 10.0;
	}
	else if ( params.search( /small/i ) != -1 )
	{
		// The parameters contained the word "small" in it.
		dist /= 10.0;
	}

	// Now we've got everything, we can perform the move.
	
	// Create 2 points, these will default to 0,0,0.
	var basept = moi.vectorMath.createPoint();
	var offsetpt = moi.vectorMath.createPoint();

	// Set up the offset point.
	offsetpt[axis] = dist;
	
	factory.setInput( 1, basept );
	factory.setInput( 2, offsetpt );
	factory.commit();
}

DoNudge();
